Index: profile/src/test/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilitiesTest.java
===================================================================
--- profile/src/test/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilitiesTest.java	(revision 7)
+++ profile/src/test/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilitiesTest.java	(revision 9)
@@ -3,4 +3,5 @@
 import static org.junit.Assert.assertEquals;
 import static org.junit.Assert.assertFalse;
+import static org.junit.Assert.assertTrue;
 
 import java.io.IOException;
@@ -81,8 +82,8 @@
 	@Override
 	public List<String> getGeneralTestStrings() {
-		return Arrays.asList("ValueSetUtilities\\{\"a\"=0.14\\}",
-				"ValueSetUtilities\\{\"b\"=0.37\\}",
-				"ValueSetUtilities\\{\"a\"=0.37\\}",
-				"ValueSetUtilities\\{\"a\"=0.14, \"b\"=0.37\\}");
+		return Arrays.asList("DiscreteValueSetUtilities\\{\"a\"=0.14\\}",
+				"DiscreteValueSetUtilities\\{\"b\"=0.37\\}",
+				"DiscreteValueSetUtilities\\{\"a\"=0.37\\}",
+				"DiscreteValueSetUtilities\\{\"a\"=0.14, \"b\"=0.37\\}");
 	}
 
@@ -200,3 +201,17 @@
 
 	}
+
+	@Test
+	public void testDeserializeAsDiscrete()
+			throws JsonParseException, JsonMappingException, IOException {
+		// Check that DiscreteValueSetUtilities properly deserializes
+		// discreteutils.
+		String utilstring = "{\"discreteutils\": {\"valueUtilities\": {\"Party Tent\": 0.52,\"Your Dorm\": 0.23,\"Party Room\": 0.99,\"Ballroom\": 0.77}}}";
+		DiscreteValueSetUtilities valueutils = jackson.readValue(utilstring,
+				DiscreteValueSetUtilities.class);
+		assertTrue(new BigDecimal("0.23").compareTo(
+				valueutils.getUtility(new DiscreteValue("Your Dorm"))) == 0);
+
+	}
+
 }
Index: profile/src/test/java/geniusweb/profile/utilityspace/LinearAdditiveTest.java
===================================================================
--- profile/src/test/java/geniusweb/profile/utilityspace/LinearAdditiveTest.java	(revision 7)
+++ profile/src/test/java/geniusweb/profile/utilityspace/LinearAdditiveTest.java	(revision 9)
@@ -20,5 +20,4 @@
 
 import com.fasterxml.jackson.databind.ObjectMapper;
-import com.fasterxml.jackson.databind.exc.InvalidDefinitionException;
 
 import geniusweb.issuevalue.Bid;
@@ -145,8 +144,8 @@
 	public List<String> getGeneralTestStrings() {
 		return Arrays.asList(
-				"LinearAdditive\\[\\{issue2=ValueSetUtilities\\{\"issue2value2\"=0.8, \"issue2value1\"=0.6\\}, issue1=ValueSetUtilities\\{\"issue1value1\"=0.3, \"issue1value2\"=0.2\\}\\},\\{issue2=0.6, issue1=0.4\\},Bid\\{issue2=\"issue2value1\", issue1=\"issue1value2\"\\}\\]",
-				"LinearAdditive\\[\\{issue2=ValueSetUtilities\\{\"issue2value2\"=0.8, \"issue2value1\"=0.6\\}, issue1=ValueSetUtilities\\{\"issue1value1\"=0.3, \"issue1value2\"=0.2\\}\\},\\{issue2=0.7, issue1=0.3\\},Bid\\{issue2=\"issue2value1\", issue1=\"issue1value2\"\\}\\]",
-				"LinearAdditive\\[\\{issue2=ValueSetUtilities\\{\"issue2value2\"=0.2, \"issue2value1\"=0.3\\}, issue1=ValueSetUtilities\\{\"issue1value1\"=0.6, \"issue1value2\"=0.8\\}\\},\\{issue2=0.6, issue1=0.4\\},Bid\\{issue2=\"issue2value1\", issue1=\"issue1value2\"\\}\\]",
-				"LinearAdditive\\[\\{issue2=ValueSetUtilities\\{\"issue2value2\"=0.2, \"issue2value1\"=0.3\\}, issue1=ValueSetUtilities\\{\"issue1value1\"=0.6, \"issue1value2\"=0.8\\}\\},\\{issue2=0.6, issue1=0.4\\},Bid\\{issue2=\"issue2value1\", issue1=\"issue1value1\"\\}\\]");
+				"LinearAdditive\\[\\{issue2=DiscreteValueSetUtilities\\{\"issue2value2\"=0.8, \"issue2value1\"=0.6\\}, issue1=DiscreteValueSetUtilities\\{\"issue1value1\"=0.3, \"issue1value2\"=0.2\\}\\},\\{issue2=0.6, issue1=0.4\\},Bid\\{issue2=\"issue2value1\", issue1=\"issue1value2\"\\}\\]",
+				"LinearAdditive\\[\\{issue2=DiscreteValueSetUtilities\\{\"issue2value2\"=0.8, \"issue2value1\"=0.6\\}, issue1=DiscreteValueSetUtilities\\{\"issue1value1\"=0.3, \"issue1value2\"=0.2\\}\\},\\{issue2=0.7, issue1=0.3\\},Bid\\{issue2=\"issue2value1\", issue1=\"issue1value2\"\\}\\]",
+				"LinearAdditive\\[\\{issue2=DiscreteValueSetUtilities\\{\"issue2value2\"=0.2, \"issue2value1\"=0.3\\}, issue1=DiscreteValueSetUtilities\\{\"issue1value1\"=0.6, \"issue1value2\"=0.8\\}\\},\\{issue2=0.6, issue1=0.4\\},Bid\\{issue2=\"issue2value1\", issue1=\"issue1value2\"\\}\\]",
+				"LinearAdditive\\[\\{issue2=DiscreteValueSetUtilities\\{\"issue2value2\"=0.2, \"issue2value1\"=0.3\\}, issue1=DiscreteValueSetUtilities\\{\"issue1value1\"=0.6, \"issue1value2\"=0.8\\}\\},\\{issue2=0.6, issue1=0.4\\},Bid\\{issue2=\"issue2value1\", issue1=\"issue1value1\"\\}\\]");
 	}
 
@@ -271,5 +270,5 @@
 	}
 
-	@Test(expected = InvalidDefinitionException.class)
+	@Test
 	public void loadFullWithJson() throws IOException {
 		String profile = new String(
Index: profile/src/test/java/geniusweb/profile/utilityspace/NumberValueSetUtilTest.java
===================================================================
--- profile/src/test/java/geniusweb/profile/utilityspace/NumberValueSetUtilTest.java	(revision 7)
+++ profile/src/test/java/geniusweb/profile/utilityspace/NumberValueSetUtilTest.java	(revision 9)
@@ -44,7 +44,7 @@
 	@Override
 	public List<String> getGeneralTestStrings() {
-		return Arrays.asList("NumberValUtility\\(12.5->0.5,18.5->0.9\\)",
-				"NumberValUtility\\(12.5->0.6,18.5->0.9\\)",
-				"NumberValUtility\\(12.5->0.5,18.4->0.9\\)");
+		return Arrays.asList("NumberValueSetUtilities\\(12.5->0.5,18.5->0.9\\)",
+				"NumberValueSetUtilities\\(12.5->0.6,18.5->0.9\\)",
+				"NumberValueSetUtilities\\(12.5->0.5,18.4->0.9\\)");
 	}
 
Index: profile/src/test/java/geniusweb/profile/utilityspace/PartsUtilitiesTest.java
===================================================================
--- profile/src/test/java/geniusweb/profile/utilityspace/PartsUtilitiesTest.java	(revision 9)
+++ profile/src/test/java/geniusweb/profile/utilityspace/PartsUtilitiesTest.java	(revision 9)
@@ -0,0 +1,144 @@
+package geniusweb.profile.utilityspace;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertTrue;
+
+import java.io.IOException;
+import java.math.BigDecimal;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.Value;
+import tudelft.utilities.junit.GeneralTests;
+
+public class PartsUtilitiesTest extends GeneralTests<PartsUtilities> {
+	private static final String iss2 = "issue2";
+
+	private static final String iss1 = "issue1";
+
+	private final ObjectMapper jackson = new ObjectMapper();
+
+	private static BigDecimal N01 = new BigDecimal("0.1"),
+			N02 = new BigDecimal("0.2"), N03 = new BigDecimal("0.3"),
+			N05 = new BigDecimal("0.5"), N07 = new BigDecimal("0.7"),
+			N08 = new BigDecimal("0.8"), N09 = new BigDecimal("0.9");
+	private final static DiscreteValue low = new DiscreteValue("low");
+	private final static DiscreteValue high = new DiscreteValue("high");
+
+	private final static String jsontext = "{\"partsutils\":{\"issues\":[\"issue1\",\"issue2\"],\"utilslist\":[{\"values\":[\"low\",\"low\"],\"util\":0.3},{\"values\":[\"high\",\"high\"],\"util\":0.9}]}}";
+
+	private PartsUtilities parts1, parts1a, parts2, parts3;
+
+	@Before
+	public void before() {
+		List<PartUtil> vals = new LinkedList<>();
+		vals.add(new PartUtil(Arrays.asList(low, low), N03));
+		vals.add(new PartUtil(Arrays.asList(high, high), N09));
+		List<PartUtil> vals1 = new LinkedList<>();
+		vals1.add(new PartUtil(Arrays.asList(low, low), N09));
+		List<String> issues = Arrays.asList(iss1, iss2);
+		parts1 = new PartsUtilities(issues, vals);
+		parts1a = new PartsUtilities(issues, vals);
+		parts2 = new PartsUtilities(Arrays.asList(iss1), vals);
+		parts3 = new PartsUtilities(issues, vals1);
+	}
+
+	@Override
+	public List<List<PartsUtilities>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(parts1, parts1a),
+				Arrays.asList(parts2), Arrays.asList(parts3));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList(
+				"PartsUtilities..issue1, issue2.,\\{.\"low\", \"low\".=0.3, .\"high\", \"high\".=0.9\\}.",
+				"PartsUtilities..issue1.,\\{.\"low\", \"low\".=0.3, .\"high\", \"high\".=0.9\\}.",
+				"PartsUtilities..issue1, issue2.,\\{.\"low\", \"low\".=0.9\\}.");
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void testWeightsTooHigh() {
+		Map<ProductOfValue, BigDecimal> utils = new HashMap<>();
+		utils.put(new ProductOfValue(Arrays.asList(low, low)),
+				new BigDecimal("1.1"));
+		new PartsUtilities(Arrays.asList(iss1, iss2), utils);
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void testWeightsTooLow() {
+		Map<ProductOfValue, BigDecimal> utils = new HashMap<>();
+		utils.put(new ProductOfValue(Arrays.asList(low, low)),
+				new BigDecimal("-0.3"));
+		new PartsUtilities(Arrays.asList(iss1, iss2), utils);
+	}
+
+	@Test
+	public void testBasicSerialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		System.out.println(jsontext);
+		assertEquals(jsontext, jackson.writeValueAsString(parts1));
+	}
+
+	@Test
+	public void testBasicDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		System.out.println(jsontext);
+		assertEquals(parts1, jackson.readValue(jsontext, PartsUtilities.class));
+	}
+
+	@Test
+	public void testGetUtility() {
+		assertEquals(N03,
+				parts1.getUtility(new ProductOfValue(Arrays.asList(low, low))));
+		assertEquals(N09, parts1
+				.getUtility(new ProductOfValue(Arrays.asList(high, high))));
+		assertEquals(BigDecimal.ZERO, parts1
+				.getUtility(new ProductOfValue(Arrays.asList(low, high))));
+	}
+
+	@Test
+	public void testGetIssues() {
+		assertEquals(Arrays.asList(iss1, iss2), parts1.getIssues());
+	}
+
+	@Test
+	public void testGetIncorrectValue() {
+		assertEquals(BigDecimal.ZERO, parts1.getUtility(low));
+	}
+
+	@Test
+	public void testGetValue() {
+		assertTrue(N03.compareTo(parts1
+				.getUtility(new ProductOfValue(Arrays.asList(low, low)))) == 0);
+	}
+
+	@Test
+	public void testMerge() {
+		Map<ProductOfValue, BigDecimal> extravals = new HashMap<>();
+		extravals.put(new ProductOfValue(Arrays.asList(low, low)),
+				N01.multiply(N05));
+		extravals.put(new ProductOfValue(Arrays.asList(high, high)),
+				N01.multiply(N07));
+		PartsUtilities extraparts = new PartsUtilities(
+				Arrays.asList("extra1", "extra2"), extravals);
+
+		PartsUtilities merged = parts1.add(extraparts);
+
+		Value pval = new ProductOfValue(Arrays.asList(low, low, high, high));
+		assertEquals(0,
+				N03.add(N01.multiply(N07)).compareTo(merged.getUtility(pval)));
+	}
+
+}
Index: profile/src/test/java/geniusweb/profile/utilityspace/ProductOfValueTest.java
===================================================================
--- profile/src/test/java/geniusweb/profile/utilityspace/ProductOfValueTest.java	(revision 9)
+++ profile/src/test/java/geniusweb/profile/utilityspace/ProductOfValueTest.java	(revision 9)
@@ -0,0 +1,78 @@
+package geniusweb.profile.utilityspace;
+
+import static org.junit.Assert.assertEquals;
+import static org.mockito.Mockito.mock;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.List;
+
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.Value;
+import tudelft.utilities.junit.GeneralTests;
+
+public class ProductOfValueTest extends GeneralTests<ProductOfValue> {
+	private final static ObjectMapper jackson = new ObjectMapper();
+
+	private final static Value value1 = new DiscreteValue("val1");
+	private final static Value value2 = new DiscreteValue("val2");
+	private final static ProductOfValue values1 = new ProductOfValue(
+			Arrays.asList(value1, value2));
+	private final static ProductOfValue values1a = new ProductOfValue(
+			Arrays.asList(value1, value2));
+	private final static ProductOfValue values2 = new ProductOfValue(
+			Arrays.asList(value2));
+	private final static DiscreteValue low = new DiscreteValue("low");
+	private final static DiscreteValue high = new DiscreteValue("high");
+
+	private String jsontext = "[\"val1\",\"val2\"]";
+
+	@Override
+	public List<List<ProductOfValue>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(values1, values1a),
+				Arrays.asList(values2));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList(".*\"val1\", \"val2\".*", ".*\"val2\".*");
+	}
+
+	@Test
+	public void testSerialize()
+			throws JsonParseException, JsonMappingException, IOException {
+
+		assertEquals(jsontext, jackson.writeValueAsString(values1));
+	}
+
+	@Test
+	public void testBasicDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		System.out.println(jsontext);
+		assertEquals(values1,
+				jackson.readValue(jsontext, ProductOfValue.class));
+	}
+
+	@Test
+	public void testMerge() {
+		Value val1 = mock(Value.class);
+		Value val2 = mock(Value.class);
+		Value val3 = mock(Value.class);
+		Value val4 = mock(Value.class);
+
+		ProductOfValue prodOfVal1 = new ProductOfValue(
+				Arrays.asList(val1, val2));
+		ProductOfValue prodOfVal2 = new ProductOfValue(
+				Arrays.asList(val3, val4));
+
+		ProductOfValue prodVal = prodOfVal1.merge(prodOfVal2);
+		assertEquals(4, prodVal.getValues().size());
+	}
+
+}
Index: profile/src/test/java/geniusweb/profile/utilityspace/SumOfGroupsUtilitySpaceTest.java
===================================================================
--- profile/src/test/java/geniusweb/profile/utilityspace/SumOfGroupsUtilitySpaceTest.java	(revision 9)
+++ profile/src/test/java/geniusweb/profile/utilityspace/SumOfGroupsUtilitySpaceTest.java	(revision 9)
@@ -0,0 +1,308 @@
+package geniusweb.profile.utilityspace;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertTrue;
+
+import java.io.IOException;
+import java.math.BigDecimal;
+import java.math.BigInteger;
+import java.nio.charset.StandardCharsets;
+import java.nio.file.Files;
+import java.nio.file.Paths;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.stream.Collectors;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.DiscreteValueSet;
+import geniusweb.issuevalue.Domain;
+import geniusweb.issuevalue.Value;
+import geniusweb.issuevalue.ValueSet;
+import geniusweb.profile.Profile;
+import tudelft.utilities.immutablelist.AbstractImmutableList;
+import tudelft.utilities.immutablelist.ImmutableList;
+import tudelft.utilities.immutablelist.Outer;
+
+public class SumOfGroupsUtilitySpaceTest {
+	private final ObjectMapper jackson = new ObjectMapper();
+	private SumOfGroupsUtilitySpace pa1;
+	private final String iss1 = "issue1", iss2 = "issue2", iss3 = "issue3";
+	private static BigDecimal N01 = new BigDecimal("0.1"),
+			N02 = new BigDecimal("0.2"), N03 = new BigDecimal("0.3"),
+			N05 = new BigDecimal("0.5"), N07 = new BigDecimal("0.7"),
+			N08 = new BigDecimal("0.8"), N09 = new BigDecimal("0.9");
+
+	private final DiscreteValue lo = new DiscreteValue("low");
+	private final DiscreteValue hi = new DiscreteValue("high");
+	private final Bid resBid = new Bid(iss1, hi);
+
+	private Domain domain;
+	private PartsUtilities putils12, putils3;
+	private String serialized = "{\"SumOfGroupsUtilitySpace\":{\"domain\":{\"name\":\"domain\",\"issuesValues\":{\"issue3\":{\"values\":[\"low\",\"high\"]},\"issue2\":{\"values\":[\"low\",\"high\"]},\"issue1\":{\"values\":[\"low\",\"high\"]}}},\"name\":\"testspace\",\"partUtilities\":{\"1and2\":{\"partsutils\":{\"issues\":[\"issue1\",\"issue2\"],\"utilslist\":[{\"values\":[\"low\",\"low\"],\"util\":0.16},{\"values\":[\"high\",\"high\"],\"util\":0.72},{\"values\":[\"low\",\"high\"],\"util\":0.16},{\"values\":[\"high\",\"low\"],\"util\":0.16}]}},\"3\":{\"partsutils\":{\"issues\":[\"issue3\"],\"utilslist\":[{\"values\":[\"low\"],\"util\":0.16},{\"values\":[\"high\"],\"util\":0.14}]}}},\"reservationbid\":{\"issuevalues\":{\"issue1\":\"high\"}}}}";
+
+	@Before
+	public void before() {
+		Map<String, ValueSet> issues = new HashMap<>();
+		issues.put(iss1, new DiscreteValueSet(lo, hi));
+		issues.put(iss2, new DiscreteValueSet(lo, hi));
+		issues.put(iss3, new DiscreteValueSet(lo, hi));
+		domain = new Domain("domain", issues);
+
+		Map<ProductOfValue, BigDecimal> utils12 = new HashMap<>();
+		// util12 has weight N08
+		utils12.put(new ProductOfValue(Arrays.asList(lo, lo)),
+				N02.multiply(N08));
+		utils12.put(new ProductOfValue(Arrays.asList(lo, hi)),
+				N02.multiply(N08));
+		utils12.put(new ProductOfValue(Arrays.asList(hi, lo)),
+				N02.multiply(N08));
+		utils12.put(new ProductOfValue(Arrays.asList(hi, hi)),
+				N09.multiply(N08));
+		putils12 = new PartsUtilities(Arrays.asList(iss1, iss2), utils12);
+
+		// utils3 has weight N02.
+		Map<ProductOfValue, BigDecimal> utils3 = new HashMap<>();
+		utils3.put(new ProductOfValue(Arrays.asList(lo)), N08.multiply(N02));
+		utils3.put(new ProductOfValue(Arrays.asList(hi)), N07.multiply(N02));
+		putils3 = new PartsUtilities(Arrays.asList(iss3), utils3);
+
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void smokeTestIncompleteProfile() {
+		HashMap<String, PartsUtilities> partutils = new HashMap<>();
+		partutils.put("1and2", putils12);
+		new SumOfGroupsUtilitySpace(domain, "testspace", partutils, resBid);
+
+	}
+
+	@Test // non-normalized utils should be fine in this case
+	public void smokeTestWeightsNotNormalized() {
+		HashMap<String, PartsUtilities> partutils = new HashMap<>();
+		partutils.put("1and2", putils12);
+		partutils.put("3", putils3);
+		new SumOfGroupsUtilitySpace(domain, "testspace", partutils, resBid);
+
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void smokeTestExtraIssue() {
+		HashMap<String, PartsUtilities> partutils = new HashMap<>();
+		partutils.put("1and2", putils12);
+		partutils.put("3", putils3);
+		partutils.put("4", putils3);
+		new SumOfGroupsUtilitySpace(domain, "testspace", partutils, resBid);
+
+	}
+
+	@Test
+	public void smokeTest() {
+		makeBasic();
+	}
+
+	@Test
+	public void testName() {
+		SumOfGroupsUtilitySpace paus = makeBasic();
+		assertEquals("testspace", paus.getName());
+	}
+
+	@Test
+	public void testDomain() {
+		SumOfGroupsUtilitySpace paus = makeBasic();
+		assertEquals(domain, paus.getDomain());
+	}
+
+	@Test
+	public void testGetResBid() {
+		SumOfGroupsUtilitySpace paus = makeBasic();
+		assertEquals(resBid, paus.getReservationBid());
+	}
+
+	@Test
+	public void testGetUtilityEmptyBid() {
+		SumOfGroupsUtilitySpace paus = makeBasic();
+		assertTrue(BigDecimal.ZERO.compareTo(
+				paus.getUtility(new Bid(Collections.emptyMap()))) == 0);
+	}
+
+	@Test
+	public void testGetUtility() {
+		SumOfGroupsUtilitySpace paus = makeBasic();
+		Map<String, Value> map = new HashMap<>();
+		map.put(iss1, lo);
+		map.put(iss2, lo); // 1,2 combined has util 0.2
+		map.put(iss3, hi); // 3 has util 0.7
+		// weights are set to 0.8, 0.2. Gives total util 0.3
+		Bid bid = new Bid(map);
+		assertTrue(N03.compareTo(paus.getUtility(bid)) == 0);
+	}
+
+	/**
+	 * Demonstrates how to convert {@link LinearAdditiveUtilitySpace} to a
+	 * {@link SumOfGroupsUtilitySpace}
+	 * 
+	 */
+	@Test
+	public void testConvertLas() throws IOException {
+		String profile = new String(
+				Files.readAllBytes(Paths.get("src/test/resources/party1.json")),
+				StandardCharsets.UTF_8);
+		LinearAdditiveUtilitySpace las = jackson.readValue(profile,
+				LinearAdditiveUtilitySpace.class);
+		SumOfGroupsUtilitySpace pas = new SumOfGroupsUtilitySpace(las);
+		checkUtilitiesAllEqual(las, pas);
+		System.out.println("Generated partial profile:\n" + pas);
+	}
+
+	/**
+	 * Demonstrates how to convert {@link LinearAdditiveUtilitySpace} to a
+	 * {@link SumOfGroupsUtilitySpace} and group some issues
+	 * 
+	 */
+	@Test
+	public void testConvertAndGroupParty() throws IOException {
+		String profile = new String(
+				Files.readAllBytes(Paths.get("src/test/resources/party1.json")),
+				StandardCharsets.UTF_8);
+		LinearAdditiveUtilitySpace las = jackson.readValue(profile,
+				LinearAdditiveUtilitySpace.class);
+		SumOfGroupsUtilitySpace pas = new SumOfGroupsUtilitySpace(las);
+		pas = pas.group(Arrays.asList("Food", "Drinks"), "food&drinks");
+		checkUtilitiesAllEqual(las, pas);
+		System.out.println("Re-grouped party profile:\n");
+		System.out.println(jackson.writeValueAsString(pas));
+
+	}
+
+	@Test
+	public void testGroupe2e() {
+		Map<ProductOfValue, BigDecimal> utils1 = new HashMap<>();
+		utils1.put(new ProductOfValue(Arrays.asList(lo)), N02.multiply(N02));
+		utils1.put(new ProductOfValue(Arrays.asList(hi)), N03.multiply(N02));
+		Map<ProductOfValue, BigDecimal> utils2 = new HashMap<>();
+		utils2.put(new ProductOfValue(Arrays.asList(lo)), N07.multiply(N03));
+		utils2.put(new ProductOfValue(Arrays.asList(hi)), N02.multiply(N03));
+		Map<ProductOfValue, BigDecimal> utils3 = new HashMap<>();
+		utils3.put(new ProductOfValue(Arrays.asList(lo)), N05.multiply(N05));
+		utils3.put(new ProductOfValue(Arrays.asList(hi)), N08.multiply(N05));
+		HashMap<String, PartsUtilities> partutils = new HashMap<>();
+		partutils.put(iss1, new PartsUtilities(Arrays.asList(iss1), utils1));
+		partutils.put(iss2, new PartsUtilities(Arrays.asList(iss2), utils2));
+		partutils.put(iss3, new PartsUtilities(Arrays.asList(iss3), utils3));
+
+		Map<String, ValueSet> issvalues = new HashMap<>();
+		issvalues.put(iss1, new DiscreteValueSet(lo, hi));
+		issvalues.put(iss2, new DiscreteValueSet(lo, hi));
+		issvalues.put(iss3, new DiscreteValueSet(lo, hi));
+		Domain domain1 = new Domain("test", issvalues);
+
+		SumOfGroupsUtilitySpace pas = new SumOfGroupsUtilitySpace(domain1,
+				"testspace", partutils, resBid);
+
+		SumOfGroupsUtilitySpace pasgrouped12 = pas
+				.group(Arrays.asList(iss1, iss2), "iss12");
+
+		checkEqualUtilities(pas, pasgrouped12);
+
+	}
+
+	@Test
+	public void testSerialize() throws JsonProcessingException {
+		SumOfGroupsUtilitySpace paus = makeBasic();
+		ObjectMapper jackson = new ObjectMapper();
+		String string = jackson.writeValueAsString(paus);
+		System.out.println(string);
+		assertEquals(serialized, string);
+
+	}
+
+	@Test
+	public void testDeserialize() throws IOException {
+		ObjectMapper jackson = new ObjectMapper();
+		assertEquals(makeBasic(), jackson.readValue(serialized, Profile.class));
+
+	}
+
+	/************************ PRIVATE FUNCTIONS *******************/
+
+	private void checkEqualUtilities(UtilitySpace space1, UtilitySpace space2) {
+		for (Bid bid : new MyAllBidsList(space1.getDomain())) {
+			assertEquals(space1.getUtility(bid), space2.getUtility(bid));
+		}
+	}
+
+	private SumOfGroupsUtilitySpace makeBasic() {
+		HashMap<String, PartsUtilities> partutils = new HashMap<>();
+		partutils.put("1and2", putils12);
+		partutils.put("3", putils3);
+		return new SumOfGroupsUtilitySpace(domain, "testspace", partutils,
+				resBid);
+
+	}
+
+	private void checkUtilitiesAllEqual(UtilitySpace space1,
+			UtilitySpace space2) {
+		for (Bid bid : new MyAllBidsList(space1.getDomain())) {
+			assertTrue(space1.getUtility(bid)
+					.compareTo(space2.getUtility(bid)) == 0);
+		}
+	}
+
+}
+
+/**
+ * Copy of AllBidsList. We can not depend on BidSpace because that would cause a
+ * cyclic dependency.
+ */
+class MyAllBidsList extends AbstractImmutableList<Bid> {
+
+	private final List<String> issues;
+	private final Outer<? extends Value> allValuePermutations;
+
+	/**
+	 * A list containing all bids in the space. This is an ImmutableList so it
+	 * can contain all bids without pre-computing them.
+	 * 
+	 */
+	public MyAllBidsList(Domain domain) {
+		if (domain == null)
+			throw new IllegalArgumentException("domain=null");
+		issues = new ArrayList<>(domain.getIssues());
+
+		List<ImmutableList<Value>> values = issues.stream()
+				.map(issue -> domain.getValues(issue))
+				.collect(Collectors.toList());
+
+		allValuePermutations = new Outer<Value>(values);
+	}
+
+	@Override
+	public Bid get(BigInteger index) {
+		ImmutableList<? extends Value> nextValues = allValuePermutations
+				.get(index);
+
+		Map<String, Value> issueValues = new HashMap<>();
+		for (int n = 0; n < issues.size(); n++) {
+			issueValues.put(issues.get(n),
+					nextValues.get(BigInteger.valueOf(n)));
+		}
+		return new Bid(issueValues);
+	}
+
+	@Override
+	public BigInteger size() {
+		return allValuePermutations.size();
+	}
+
+}
Index: profile/src/test/resources/party1.json
===================================================================
--- profile/src/test/resources/party1.json	(revision 7)
+++ profile/src/test/resources/party1.json	(revision 9)
@@ -92,5 +92,5 @@
 				"Location": {
 					"values": [
-						"Party Tent'",
+						"Party Tent",
 						"Your Dorm",
 						"Party Room",