Index: /bidspace/pom.xml
===================================================================
--- /bidspace/pom.xml	(revision 10)
+++ /bidspace/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>bidspace</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -36,5 +36,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>profile</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 
Index: /events/pom.xml
===================================================================
--- /events/pom.xml	(revision 10)
+++ /events/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>events</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -43,10 +43,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>issuevalue</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>references</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 
Index: /exampleparties/boulware/pom.xml
===================================================================
--- /exampleparties/boulware/pom.xml	(revision 10)
+++ /exampleparties/boulware/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>boulware</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb.exampleparties</groupId>
 			<artifactId>timedependentparty</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
Index: /exampleparties/comparebids/pom.xml
===================================================================
--- /exampleparties/comparebids/pom.xml	(revision 10)
+++ /exampleparties/comparebids/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>comparebids</artifactId>
-	<version>1.0.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 
@@ -39,10 +39,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
Index: /exampleparties/conceder/pom.xml
===================================================================
--- /exampleparties/conceder/pom.xml	(revision 10)
+++ /exampleparties/conceder/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>conceder</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb.exampleparties</groupId>
 			<artifactId>timedependentparty</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
Index: /exampleparties/hardliner/pom.xml
===================================================================
--- /exampleparties/hardliner/pom.xml	(revision 10)
+++ /exampleparties/hardliner/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>hardliner</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb.exampleparties</groupId>
 			<artifactId>timedependentparty</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
Index: /exampleparties/humangui/pom.xml
===================================================================
--- /exampleparties/humangui/pom.xml	(revision 10)
+++ /exampleparties/humangui/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>humangui</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 
@@ -39,5 +39,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
@@ -49,5 +49,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
Index: /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/HumanGuiTest.java
===================================================================
--- /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/HumanGuiTest.java	(revision 10)
+++ /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/HumanGuiTest.java	(revision 11)
@@ -47,5 +47,5 @@
 public class HumanGuiTest {
 
-	private static final ProtocolRef SAOP = new ProtocolRef("SAOP");
+	private static final String SAOP = "SAOP";
 	private static final PartyId otherparty = new PartyId("other");
 	private static final String PROFILE = "src/test/resources/testprofile.json";
Index: /exampleparties/linear/pom.xml
===================================================================
--- /exampleparties/linear/pom.xml	(revision 10)
+++ /exampleparties/linear/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>linear</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb.exampleparties</groupId>
 			<artifactId>timedependentparty</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
Index: /exampleparties/pom.xml
===================================================================
--- /exampleparties/pom.xml	(revision 10)
+++ /exampleparties/pom.xml	(revision 11)
@@ -22,4 +22,5 @@
 		<module>hardliner</module>
 		<module>boulware</module>
+		<module>humangui</module>
 		<module>linear</module>
 		<module>simpleshaop</module>
Index: /exampleparties/randomparty/pom.xml
===================================================================
--- /exampleparties/randomparty/pom.xml	(revision 10)
+++ /exampleparties/randomparty/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>randomparty</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 
@@ -39,10 +39,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
Index: /exampleparties/randompartypy/pom.xml
===================================================================
--- /exampleparties/randompartypy/pom.xml	(revision 10)
+++ /exampleparties/randompartypy/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>randompyparty</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -31,5 +31,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>pythonadapter</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 
@@ -37,10 +37,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
Index: /exampleparties/simpleshaop/pom.xml
===================================================================
--- /exampleparties/simpleshaop/pom.xml	(revision 10)
+++ /exampleparties/simpleshaop/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>simpleshaop</artifactId>
-	<version>1.0.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 
@@ -39,10 +39,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
Index: /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java
===================================================================
--- /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java	(revision 10)
+++ /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java	(revision 11)
@@ -15,5 +15,5 @@
 import geniusweb.actions.Offer;
 import geniusweb.actions.PartyId;
-import geniusweb.bidspace.AllPartialBidsList;
+import geniusweb.bidspace.AllBidsList;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
@@ -132,5 +132,5 @@
 
 	private Offer randomBid() throws IOException {
-		AllPartialBidsList bidspace = new AllPartialBidsList(
+		AllBidsList bidspace = new AllBidsList(
 				profileint.getProfile().getDomain());
 		long i = random.nextInt(bidspace.size().intValue());
Index: /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/SimpleLinearOrdering.java
===================================================================
--- /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/SimpleLinearOrdering.java	(revision 10)
+++ /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/SimpleLinearOrdering.java	(revision 11)
@@ -94,10 +94,10 @@
 		DefaultPartialOrdering prof = (DefaultPartialOrdering) profile;
 		List<Bid> bidslist = prof.getBids();
+		// NOTE sort defaults to ascending order, this is missing in docs.
 		Collections.sort(bidslist, new Comparator<Bid>() {
 
 			@Override
 			public int compare(Bid b1, Bid b2) {
-				// notice, -1 if better because WORST bid first
-				return prof.isPreferredOrEqual(b1, b2) ? -1 : 1;
+				return prof.isPreferredOrEqual(b1, b2) ? 1 : -1;
 			}
 
Index: /exampleparties/simpleshaop/src/test/java/geniusweb/exampleparties/simpleshaop/SimpleLinearOrderingTest.java
===================================================================
--- /exampleparties/simpleshaop/src/test/java/geniusweb/exampleparties/simpleshaop/SimpleLinearOrderingTest.java	(revision 10)
+++ /exampleparties/simpleshaop/src/test/java/geniusweb/exampleparties/simpleshaop/SimpleLinearOrderingTest.java	(revision 11)
@@ -64,5 +64,5 @@
 		SimpleLinearOrdering testprofile = new SimpleLinearOrdering(
 				realprofile);
-		assertEquals(Arrays.asList(bid3, bid2, bid1), testprofile.getBids());
+		assertEquals(Arrays.asList(bid1, bid2, bid3), testprofile.getBids());
 	}
 
Index: /exampleparties/timedependentparty/pom.xml
===================================================================
--- /exampleparties/timedependentparty/pom.xml	(revision 10)
+++ /exampleparties/timedependentparty/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>timedependentparty</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 
@@ -39,10 +39,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
Index: /issuevalue/pom.xml
===================================================================
--- /issuevalue/pom.xml	(revision 10)
+++ /issuevalue/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>issuevalue</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
Index: /party/pom.xml
===================================================================
--- /party/pom.xml	(revision 10)
+++ /party/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>party</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -31,20 +31,20 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>timeline</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profile</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>events</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>references</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
Index: /profile/pom.xml
===================================================================
--- /profile/pom.xml	(revision 10)
+++ /profile/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>profile</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -31,10 +31,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>issuevalue</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>references</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 
Index: /profileconnection/pom.xml
===================================================================
--- /profileconnection/pom.xml	(revision 10)
+++ /profileconnection/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>profileconnection</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -31,5 +31,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>profile</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 
Index: /profileconnection/src/main/java/geniusweb/profileconnection/WebsocketProfileConnector.java
===================================================================
--- /profileconnection/src/main/java/geniusweb/profileconnection/WebsocketProfileConnector.java	(revision 10)
+++ /profileconnection/src/main/java/geniusweb/profileconnection/WebsocketProfileConnector.java	(revision 11)
@@ -27,4 +27,5 @@
 	private static final int TIMEOUT_MS = 2000;
 	private final Reporter logger;
+	private final URI uri; // to log possible errors
 	private Profile profile = null;
 
@@ -46,4 +47,5 @@
 					"uri, reporter and wsconnector must be not null");
 		}
+		this.uri = uri;
 		this.logger = reporter;
 		wscontainer.connectToServer(this, uri);
@@ -81,5 +83,5 @@
 		}
 		if (profile == null) {
-			throw new IOException("Failed to fetch profile");
+			throw new IOException("Failed to fetch profile from " + uri);
 		}
 		return profile;
Index: /protocol/pom.xml
===================================================================
--- /protocol/pom.xml	(revision 10)
+++ /protocol/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>protocol</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -31,20 +31,20 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>profile</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>references</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>events</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
Index: /protocol/src/main/java/geniusweb/protocol/session/SessionState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/SessionState.java	(revision 10)
+++ /protocol/src/main/java/geniusweb/protocol/session/SessionState.java	(revision 11)
@@ -10,4 +10,5 @@
 import geniusweb.protocol.NegoState;
 import geniusweb.protocol.session.saop.SAOPState;
+import geniusweb.protocol.session.shaop.SHAOPState;
 
 /**
@@ -33,5 +34,6 @@
  * the protocol. As uaual, mark non-serializable fields as transient.
  */
-@JsonSubTypes({ @JsonSubTypes.Type(value = SAOPState.class) })
+@JsonSubTypes({ @JsonSubTypes.Type(value = SAOPState.class),
+		@JsonSubTypes.Type(value = SHAOPState.class) })
 
 public interface SessionState extends NegoState {
Index: /protocol/src/main/java/geniusweb/protocol/session/shaop/BareSHAOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/shaop/BareSHAOPState.java	(revision 10)
+++ /protocol/src/main/java/geniusweb/protocol/session/shaop/BareSHAOPState.java	(revision 11)
@@ -32,5 +32,5 @@
 	protected final ProtocolException error;
 
-	protected final int actorNr;
+	protected final int teamNr;
 
 	protected final Map<PartyId, Integer> partyNumbers;
@@ -43,7 +43,8 @@
 	 *                   list
 	 * @param conns      the currently existing connections. Can be empty/null.
-	 *                   Each connection represents another party. Normally
-	 *                   there is exactly 1 connection for every party. The
-	 *                   protocol should check this.
+	 *                   Each connection represents another party. Normally the
+	 *                   connections are in the order SHAOP1,COB1,SHAOP2,COB2,..
+	 *                   so 2 parties for each team. The protocol should check
+	 *                   this.
 	 * @param progr      the {@link Progress} that governs this session. Can be
 	 *                   null if session did not yet start.
@@ -54,5 +55,6 @@
 	 *                   are bugs (not ProtocolExceptions) and should result in
 	 *                   a throw.
-	 * @param actorNr    the actor that has the turn, index {@link #connections}
+	 * @param teamNr     the teamnr (0,1,2..) that has the turn. 2* gives index
+	 *                   {@link #connections} and settings
 	 * @param partyNrs   a map for each known PartyId to a number. The number is
 	 *                   the index in both {@link SHAOPSettings#getTeams()} and
@@ -64,5 +66,5 @@
 	public BareSHAOPState(List<Action> actions,
 			ProtocolToPartyConnections conns, Progress progr,
-			SHAOPSettings settings, ProtocolException e, int actorNr,
+			SHAOPSettings settings, ProtocolException e, int teamNr,
 			Map<PartyId, Integer> partyNrs, Map<PartyId, Double> spent) {
 		if (conns == null) {
@@ -97,5 +99,5 @@
 		this.settings = settings;
 		this.error = e;
-		this.actorNr = actorNr;
+		this.teamNr = teamNr;
 	}
 
@@ -106,8 +108,8 @@
 	/**
 	 * 
-	 * @return party ID of current actorNr
+	 * @return party ID of current team leader (SHAOP party)
 	 */
-	public PartyId getCurrentActor() {
-		return connections.get(actorNr).getParty();
+	public PartyId getCurrentTeam() {
+		return connections.get(2 * teamNr).getParty();
 	}
 
Index: /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOP.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOP.java	(revision 10)
+++ /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOP.java	(revision 11)
@@ -313,5 +313,5 @@
 					.send(new ActionDone(action));
 		} else {
-			if (!partyconn.getParty().equals(state.getCurrentActor()))
+			if (!partyconn.getParty().equals(state.getCurrentTeam()))
 				throw new ProtocolException(
 						"Party acts without having the turn",
@@ -331,5 +331,5 @@
 	 */
 	private synchronized void nextTurn() {
-		PartyId party = state.getCurrentActor();
+		PartyId party = state.getCurrentTeam();
 		try {
 			state.getConnections().get(party).send(new YourTurn());
Index: /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPSettings.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPSettings.java	(revision 10)
+++ /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPSettings.java	(revision 11)
@@ -62,13 +62,4 @@
 
 	/**
-	 * 
-	 * @param n an index number into the {@link #getTeams()} list.
-	 * @return true iff that participant is a SHAOP party.
-	 */
-	public boolean isShaopParty(int n) {
-		return (n & 1) == 0;
-	}
-
-	/**
 	 * @return the deadline for this negotiation
 	 */
@@ -83,4 +74,5 @@
 	 *         party.
 	 */
+	@Override
 	public List<PartyWithProfile> getAllParties() {
 		return participants.stream().map(team -> team.getAllParties())
Index: /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPState.java	(revision 10)
+++ /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPState.java	(revision 11)
@@ -41,8 +41,8 @@
 			@JsonProperty("settings") SHAOPSettings settings,
 			@JsonProperty("error") ProtocolException e,
-			@JsonProperty("actorNr") int actorNr,
+			@JsonProperty("teamNr") int teamNr,
 			@JsonProperty("partyNumbers") Map<PartyId, Integer> partytNumbers,
 			@JsonProperty("totalSpent") Map<PartyId, Double> spent) {
-		super(actions, conns, progress, settings, e, actorNr, partytNumbers,
+		super(actions, conns, progress, settings, e, teamNr, partytNumbers,
 				spent);
 	}
@@ -73,5 +73,5 @@
 	 */
 	public boolean isShaopParty(PartyId party) {
-		return settings.isShaopParty(partyNumbers.get(party));
+		return (partyNumbers.get(party) & 1) == 0;
 	}
 
@@ -79,5 +79,5 @@
 	 * 
 	 * @param party a Party Id
-	 * @return the PartyId of the party
+	 * @return the PartyId of the party (COB and SHAOP are partners)
 	 */
 	public PartyId getPartner(PartyId party) {
@@ -132,5 +132,5 @@
 		newNumbers.put(connection.getParty(), connections.size());
 		return new SHAOPState(actions, newconns, progress, settings, null,
-				actorNr, newNumbers, totalSpent);
+				teamNr, newNumbers, totalSpent);
 	}
 
@@ -144,5 +144,5 @@
 	public SHAOPState with(ProtocolException e) {
 		return new SHAOPState(actions, connections, progress, settings, e,
-				actorNr, partyNumbers, totalSpent);
+				teamNr, partyNumbers, totalSpent);
 	}
 
@@ -162,5 +162,5 @@
 		}
 		return new SHAOPState(actions, connections, newprogress, settings,
-				error, actorNr, partyNumbers, totalSpent);
+				error, teamNr, partyNumbers, totalSpent);
 	}
 
@@ -259,5 +259,5 @@
 		List<Action> newactions = new LinkedList<>(getActions());
 		newactions.add(action);
-		int newActor = actorNr;
+		int newTeam = teamNr;
 		if (action instanceof ElicitComparison) {
 			Object cost = getPartyProfile(partyid).getParty().getParameters()
@@ -276,5 +276,5 @@
 		} else {
 			// shaop party does real action, move to next SHAOP party.
-			newActor = (actorNr + 2) % settings.getTeams().size();
+			newTeam = (teamNr + 1) % settings.getTeams().size();
 			if (newprogress instanceof ProgressRounds) {
 				newprogress = ((ProgressRounds) newprogress).advance();
@@ -282,5 +282,5 @@
 		}
 		return new SHAOPState(newactions, connections, newprogress, settings,
-				null, newActor, partyNumbers, newSpent);
+				null, newTeam, partyNumbers, newSpent);
 
 	}
@@ -298,7 +298,7 @@
 		if (!isShaopParty(actor))
 			throw new IllegalArgumentException(
-					"Illegal action for COB party" + action);
+					"Only SHAOP party can execute " + action);
 		// real action only allowed if party has the turn.
-		if (!actor.equals(connections.get(actorNr).getParty())) {
+		if (!actor.equals(connections.get(2 * teamNr).getParty())) {
 			throw new IllegalArgumentException("Party does not have the turn ");
 		}
Index: /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettings.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettings.java	(revision 10)
+++ /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettings.java	(revision 11)
@@ -67,4 +67,5 @@
 public class AllPermutationsSettings implements TournamentSettings {
 
+	public static final String COB_PARTY = "comparebids-1.2.0";
 	private final List<PartyWithParameters> parties;
 	private final List<ProfileRef> profiles;
@@ -292,5 +293,5 @@
 			PartyWithParameters cobparty = new PartyWithParameters(new PartyRef(
 					partyuri.getScheme() + "://" + partyuri.getAuthority()
-							+ partypath + "/comparebids-1.0.0"),
+							+ partypath + "/" + COB_PARTY),
 					new Parameters());
 			return new PartyWithProfile(cobparty, cobprof);
Index: /protocol/src/test/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettingsTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettingsTest.java	(revision 10)
+++ /protocol/src/test/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettingsTest.java	(revision 11)
@@ -187,9 +187,9 @@
 		String query = "?a=2&partial=4";
 		PartyWithProfile partyprofile = AllPermutationsSettings.makeCob(
-				new PartyRef(partybase + "simpleshaop-1.0.0"),
+				new PartyRef(partybase + AllPermutationsSettings.COB_PARTY),
 				new ProfileRef(profilebase + query));
 		assertEquals(profilebase,
 				partyprofile.getProfile().getURI().toString());
-		assertEquals(partybase + "comparebids-1.0.0",
+		assertEquals(partybase + AllPermutationsSettings.COB_PARTY,
 				partyprofile.getParty().getPartyRef().getURI().toString());
 	}
Index: /pythonadapter/pom.xml
===================================================================
--- /pythonadapter/pom.xml	(revision 10)
+++ /pythonadapter/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>pythonadapter</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -31,5 +31,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 
Index: /references/pom.xml
===================================================================
--- /references/pom.xml	(revision 10)
+++ /references/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>references</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
Index: /simplerunner/pom.xml
===================================================================
--- /simplerunner/pom.xml	(revision 10)
+++ /simplerunner/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>simplerunner</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 
@@ -31,15 +31,15 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>protocol</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb.exampleparties</groupId>
 			<artifactId>randomparty</artifactId>
-			<version>1.1.0</version>
+			<version>1.2.0</version>
 			<scope>test</scope>
 		</dependency>
@@ -47,5 +47,5 @@
 			<groupId>geniusweb.exampleparties</groupId>
 			<artifactId>comparebids</artifactId>
-			<version>1.0.0</version>
+			<version>1.2.0</version>
 			<scope>test</scope>
 		</dependency>
@@ -53,5 +53,5 @@
 			<groupId>geniusweb.exampleparties</groupId>
 			<artifactId>simpleshaop</artifactId>
-			<version>1.0.0</version>
+			<version>1.2.0</version>
 			<scope>test</scope>
 		</dependency>
Index: /timeline/pom.xml
===================================================================
--- /timeline/pom.xml	(revision 10)
+++ /timeline/pom.xml	(revision 11)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>timeline</artifactId>
-	<version>1.1.0</version>
+	<version>1.2.0</version>
 	<packaging>jar</packaging>
 