Index: exampleparties/anac2019/agentgg/pom.xml
===================================================================
--- exampleparties/anac2019/agentgg/pom.xml	(revision 12)
+++ exampleparties/anac2019/agentgg/pom.xml	(revision 13)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties.anac2019</groupId>
 	<artifactId>agentgg</artifactId>
-	<version>1.2.0</version>
+	<version>1.3.1</version>
 	<packaging>jar</packaging>
 
@@ -32,5 +32,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>issuevalue</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 
@@ -38,5 +38,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 
@@ -44,10 +44,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
@@ -145,5 +145,5 @@
 		<pluginRepository>
 			<id>jcenter</id>
-			<url>http://jcenter.bintray.com</url>
+			<url>https://jcenter.bintray.com</url>
 		</pluginRepository>
 	</pluginRepositories>
Index: exampleparties/anac2019/winkyagent/pom.xml
===================================================================
--- exampleparties/anac2019/winkyagent/pom.xml	(revision 12)
+++ exampleparties/anac2019/winkyagent/pom.xml	(revision 13)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties.anac2019</groupId>
 	<artifactId>winkyagent</artifactId>
-	<version>1.2.0</version>
+	<version>1.3.1</version>
 	<packaging>jar</packaging>
 
@@ -32,5 +32,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>issuevalue</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 
@@ -38,5 +38,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 
@@ -44,10 +44,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
@@ -145,5 +145,5 @@
 		<pluginRepository>
 			<id>jcenter</id>
-			<url>http://jcenter.bintray.com</url>
+			<url>https://jcenter.bintray.com</url>
 		</pluginRepository>
 	</pluginRepositories>
Index: exampleparties/boulware/pom.xml
===================================================================
--- exampleparties/boulware/pom.xml	(revision 12)
+++ exampleparties/boulware/pom.xml	(revision 13)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>boulware</artifactId>
-	<version>1.2.0</version>
+			<version>1.3.1</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb.exampleparties</groupId>
 			<artifactId>timedependentparty</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
@@ -58,5 +58,5 @@
 		<pluginRepository>
 			<id>jcenter</id>
-			<url>http://jcenter.bintray.com</url>
+			<url>https://jcenter.bintray.com</url>
 		</pluginRepository>
 	</pluginRepositories>
Index: exampleparties/comparebids/pom.xml
===================================================================
--- exampleparties/comparebids/pom.xml	(revision 12)
+++ exampleparties/comparebids/pom.xml	(revision 13)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>comparebids</artifactId>
-	<version>1.2.0</version>
+			<version>1.3.1</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 
@@ -39,10 +39,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
@@ -140,5 +140,5 @@
 		<pluginRepository>
 			<id>jcenter</id>
-			<url>http://jcenter.bintray.com</url>
+			<url>https://jcenter.bintray.com</url>
 		</pluginRepository>
 	</pluginRepositories>
Index: exampleparties/conceder/pom.xml
===================================================================
--- exampleparties/conceder/pom.xml	(revision 12)
+++ exampleparties/conceder/pom.xml	(revision 13)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>conceder</artifactId>
-	<version>1.2.0</version>
+			<version>1.3.1</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb.exampleparties</groupId>
 			<artifactId>timedependentparty</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
@@ -58,5 +58,5 @@
 		<pluginRepository>
 			<id>jcenter</id>
-			<url>http://jcenter.bintray.com</url>
+			<url>https://jcenter.bintray.com</url>
 		</pluginRepository>
 	</pluginRepositories>
Index: exampleparties/hardliner/pom.xml
===================================================================
--- exampleparties/hardliner/pom.xml	(revision 12)
+++ exampleparties/hardliner/pom.xml	(revision 13)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>hardliner</artifactId>
-	<version>1.2.0</version>
+			<version>1.3.1</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb.exampleparties</groupId>
 			<artifactId>timedependentparty</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
@@ -58,5 +58,5 @@
 		<pluginRepository>
 			<id>jcenter</id>
-			<url>http://jcenter.bintray.com</url>
+			<url>https://jcenter.bintray.com</url>
 		</pluginRepository>
 	</pluginRepositories>
Index: exampleparties/humangui/pom.xml
===================================================================
--- exampleparties/humangui/pom.xml	(revision 12)
+++ exampleparties/humangui/pom.xml	(revision 13)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>humangui</artifactId>
-	<version>1.2.0</version>
+			<version>1.3.1</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 
@@ -39,5 +39,15 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
+		</dependency>
+		<dependency>
+			<groupId>geniusweb</groupId>
+			<artifactId>profileconnection</artifactId>
+			<version>1.3.1</version>
+		</dependency>
+		<dependency>
+			<groupId>tudelft.utilities</groupId>
+			<artifactId>immutablelist</artifactId>
+			<version>1.0.1</version>
 		</dependency>
 		<dependency>
@@ -45,14 +55,4 @@
 			<artifactId>logging</artifactId>
 			<version>1.0.0</version>
-		</dependency>
-		<dependency>
-			<groupId>geniusweb</groupId>
-			<artifactId>profileconnection</artifactId>
-			<version>1.2.0</version>
-		</dependency>
-		<dependency>
-			<groupId>tudelft.utilities</groupId>
-			<artifactId>immutablelist</artifactId>
-			<version>1.0.1</version>
 		</dependency>
 
@@ -140,5 +140,5 @@
 		<pluginRepository>
 			<id>jcenter</id>
-			<url>http://jcenter.bintray.com</url>
+			<url>https://jcenter.bintray.com</url>
 		</pluginRepository>
 	</pluginRepositories>
Index: exampleparties/linear/pom.xml
===================================================================
--- exampleparties/linear/pom.xml	(revision 12)
+++ exampleparties/linear/pom.xml	(revision 13)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>linear</artifactId>
-	<version>1.2.0</version>
+			<version>1.3.1</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb.exampleparties</groupId>
 			<artifactId>timedependentparty</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
@@ -58,5 +58,5 @@
 		<pluginRepository>
 			<id>jcenter</id>
-			<url>http://jcenter.bintray.com</url>
+			<url>https://jcenter.bintray.com</url>
 		</pluginRepository>
 	</pluginRepositories>
Index: exampleparties/randomparty/pom.xml
===================================================================
--- exampleparties/randomparty/pom.xml	(revision 12)
+++ exampleparties/randomparty/pom.xml	(revision 13)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>randomparty</artifactId>
-	<version>1.2.0</version>
+	<version>1.3.1</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 
@@ -39,10 +39,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
@@ -140,5 +140,5 @@
 		<pluginRepository>
 			<id>jcenter</id>
-			<url>http://jcenter.bintray.com</url>
+			<url>https://jcenter.bintray.com</url>
 		</pluginRepository>
 	</pluginRepositories>
Index: exampleparties/randompartypy/pom.xml
===================================================================
--- exampleparties/randompartypy/pom.xml	(revision 12)
+++ exampleparties/randompartypy/pom.xml	(revision 13)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>randompyparty</artifactId>
-	<version>1.2.0</version>
+	<version>1.3.1</version>
 	<packaging>jar</packaging>
 
@@ -31,5 +31,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>pythonadapter</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 
@@ -37,10 +37,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
@@ -131,5 +131,5 @@
 		<pluginRepository>
 			<id>jcenter</id>
-			<url>http://jcenter.bintray.com</url>
+			<url>https://jcenter.bintray.com</url>
 		</pluginRepository>
 	</pluginRepositories>
Index: exampleparties/simpleshaop/pom.xml
===================================================================
--- exampleparties/simpleshaop/pom.xml	(revision 12)
+++ exampleparties/simpleshaop/pom.xml	(revision 13)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>simpleshaop</artifactId>
-	<version>1.2.0</version>
+	<version>1.3.1</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 
@@ -39,10 +39,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
@@ -140,5 +140,5 @@
 		<pluginRepository>
 			<id>jcenter</id>
-			<url>http://jcenter.bintray.com</url>
+			<url>https://jcenter.bintray.com</url>
 		</pluginRepository>
 	</pluginRepositories>
Index: exampleparties/timedependentparty/pom.xml
===================================================================
--- exampleparties/timedependentparty/pom.xml	(revision 12)
+++ exampleparties/timedependentparty/pom.xml	(revision 13)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>timedependentparty</artifactId>
-	<version>1.2.0</version>
+	<version>1.3.1</version>
 	<packaging>jar</packaging>
 
@@ -33,5 +33,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 
@@ -39,10 +39,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.2.0</version>
+			<version>1.3.1</version>
 		</dependency>
 		<dependency>
@@ -140,5 +140,5 @@
 		<pluginRepository>
 			<id>jcenter</id>
-			<url>http://jcenter.bintray.com</url>
+			<url>https://jcenter.bintray.com</url>
 		</pluginRepository>
 	</pluginRepositories>
@@ -171,5 +171,5 @@
 				</executions>
 			</plugin>
-			
+
 			<plugin>
 				<groupId>org.apache.maven.plugins</groupId>