Index: javavenv/src/test/java/geniusweb/javavenv/PythonCallTest.java
===================================================================
--- javavenv/src/test/java/geniusweb/javavenv/PythonCallTest.java	(revision 14)
+++ 	(revision )
@@ -1,122 +1,0 @@
-package geniusweb.javavenv;
-
-import static org.junit.Assert.assertEquals;
-
-import java.io.IOException;
-import java.util.Arrays;
-
-import org.junit.Test;
-
-public class PythonCallTest {
-
-	@Test(expected = IllegalArgumentException.class)
-	public void testSmokeNullPython() {
-		new Call(null, Arrays.asList("troep"), 1000);
-	}
-
-	@Test
-	public void testSmokeNoSuchPython() {
-		new Call("/a/c/e", Arrays.asList("troep"), 1000);
-	}
-
-	@Test(expected = IllegalArgumentException.class)
-	public void testSmokeEmptyArg() {
-		new Call(PythonVenv.PYTHON3, null, 1000);
-	}
-
-	@Test
-	public void testSmoke() {
-		new Call(PythonVenv.PYTHON3, Arrays.asList("troep"), 1000);
-	}
-
-	@Test
-	public void testNonsenseCall()
-			throws InterruptedException, IOException, PythonError {
-		try {
-			Call c = new Call(PythonVenv.PYTHON3,
-					Arrays.asList("troep"), 1000);
-			c.run();
-		} catch (PythonError e) {
-			System.out.println("Correctly received Pythonerror:" + e);
-			return;
-		}
-		throw new IllegalStateException("Expected error did not occur");
-	}
-
-	@Test
-	public void testPrint()
-			throws InterruptedException, IOException, PythonError {
-		Call c = new Call(PythonVenv.PYTHON3,
-				Arrays.asList("src/test/resources/print.py"), 1000);
-		assertEquals("hello\n", c.run());
-	}
-
-	@Test
-	public void testPrintNoNewline()
-			throws InterruptedException, IOException, PythonError {
-		Call c = new Call(PythonVenv.PYTHON3,
-				Arrays.asList("src/test/resources/printnonewline.py"), 1000);
-		assertEquals("hello", c.run());
-	}
-
-	@Test
-	public void testPrint3xNoNewline()
-			throws InterruptedException, IOException, PythonError {
-		Call c = new Call(PythonVenv.PYTHON3,
-				Arrays.asList("src/test/resources/print3xnonewline.py"), 1000);
-		// the call collects till the connection closes, also if it's multi
-		// lines
-		assertEquals("hellothis is another messageAnd another", c.run());
-	}
-
-	@Test
-	public void testWait5Sec()
-			throws InterruptedException, IOException, PythonError {
-		Call c = new Call(PythonVenv.PYTHON3,
-				Arrays.asList("src/test/resources/wait5sec.py"), 10000);
-		assertEquals("hello world\n", c.run());
-	}
-
-	@Test
-	public void testWait5SecInHurry()
-			throws InterruptedException, IOException, PythonError {
-		try {
-			Call c = new Call(PythonVenv.PYTHON3,
-					Arrays.asList("src/test/resources/wait5sec.py"), 1000);
-			c.run();
-		} catch (InterruptedException e) {
-			System.out.println("Correctly received InterruptedException:" + e);
-			return;
-		}
-		throw new IllegalStateException("Expected error did not occur");
-	}
-
-	@Test
-	public void testPrintErr()
-			throws InterruptedException, IOException, PythonError {
-		try {
-			Call c = new Call(PythonVenv.PYTHON3,
-					Arrays.asList("src/test/resources/printerr.py"), 1000);
-			c.run();
-		} catch (PythonError e) {
-			System.out.println("Correctly received Pythonerror:" + e);
-			return;
-		}
-		throw new IllegalStateException("Expected error did not occur");
-	}
-
-	@Test
-	public void testThrow()
-			throws InterruptedException, IOException, PythonError {
-		try {
-			Call c = new Call(PythonVenv.PYTHON3,
-					Arrays.asList("src/test/resources/throw.py"), 1000);
-			c.run();
-		} catch (PythonError e) {
-			System.out.println("Correctly received Pythonerror:" + e);
-			return;
-		}
-		throw new IllegalStateException("Expected error did not occur");
-	}
-
-}
Index: javavenv/src/test/java/geniusweb/javavenv/PythonPartyFactoryE2E.java
===================================================================
--- javavenv/src/test/java/geniusweb/javavenv/PythonPartyFactoryE2E.java	(revision 14)
+++ javavenv/src/test/java/geniusweb/javavenv/PythonPartyFactoryE2E.java	(revision 15)
@@ -30,4 +30,5 @@
 import geniusweb.references.Reference;
 import tudelft.utilities.listener.DefaultListenable;
+import tudelft.utilities.pyrunner.PythonError;
 
 public class PythonPartyFactoryE2E {
Index: javavenv/src/test/java/geniusweb/javavenv/PythonVenvTest.java
===================================================================
--- javavenv/src/test/java/geniusweb/javavenv/PythonVenvTest.java	(revision 14)
+++ 	(revision )
@@ -1,47 +1,0 @@
-package geniusweb.javavenv;
-
-import java.io.IOException;
-
-import org.junit.Test;
-
-import tudelft.utilities.logging.ReportToLogger;
-import tudelft.utilities.logging.Reporter;
-
-/**
- * Contains a Python Venv for a specific python tar.gz file.
- *
- */
-public class PythonVenvTest {
-	private final Reporter logger = new ReportToLogger("test");
-
-	// "." and "-" not allowed in the name, only _
-	@Test(expected = IllegalArgumentException.class)
-	public void badNameTest()
-			throws IOException, InterruptedException, PythonError {
-		PythonVenv env = new PythonVenv("stupidparty-1.0.0", logger);
-		env.remove();
-	}
-
-	@Test
-	public void test() throws IOException, InterruptedException, PythonError {
-		PythonVenv env = new PythonVenv("python3party100", logger);
-		env.remove();
-	}
-
-	/**
-	 * One test for both pip list and pip install, because user may have to give
-	 * permission for each venv separately
-	 */
-	@Test
-	public void testPipInstallNumpy()
-			throws IOException, InterruptedException, PythonError {
-		PythonVenv env = new PythonVenv("python3party100", logger);
-		env.call("-m pip install --upgrade pip", 20000);
-		String res = env.call("-m pip list", 10000);
-		System.out.println("pip list gave " + res);
-		res = env.call("-m pip install numpy", 30000);
-		System.out.println("pip install numpy gave " + res);
-		env.remove();
-	}
-
-}